try:
    import usocket as socket
except:
    import socket
import json
configpage = '<html><head><title>Configseite</title></head><body><h1>huhu</h1></body></html>'

class HTTPServer():
    def __init__(self, ip, port):
        self.ip = ip
        self.port = port

        self.socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.socket.setblocking(False)
        self.socket.bind((ip, port))
        self.socket.listen()

    def __del__(self):
        self.close()

    def close(self):
        self.socket.close()

    
    def checkdata(self, dmx, f):
        try:
            conn, address = self.socket.accept()
        except OSError as e:
            err = e.args[0]
            if err != 11:
                raise e
        else:
            request = conn.recv(1024).decode()
            print(request)
            requestline = request.split('\n')[0]
            headers = dict(headerpair.split(': ') for headerpair in request.split('\n')[1:])
            method = requestline.split()[0]
            requestpath = requestline.split()[1].split("?", 1)
            query = dict()
            if len(requestpath) > 1:
                query = dict(querypair.split('=') for querypair in requestpath[1].split('&'))
            if method == 'POST':
                if 'Content-Length' in headers and 'Content-Type' in headers:
                    if headers['Content-Type'] == 'application/json':
                        try:
                            body = json.loads(request[len(request)-headers['Content-Length']:])
                        except ValueError:
                            self.sendresponse(conn, 'HTTP/1.0 415 Unsupported Media Type\n\nUnsupported Media Type')
                            return -1
                    else:
                        self.sendresponse(conn, 'HTTP/1.0 415 Unsupported Media Type\n\nUnsupported Media Type')
                        return -1
                else:
                    self.sendresponse(conn, 'HTTP/1.0 411 Length Required\n\nLength Required')
                    return -1
            if requestpath[0] == '/' and method == 'GET':
                self.sendresponse(conn, 'HTTP/1.0 200 OK\nConnection: close\nContent-Length: %s\nContent-Type: text/html; charset=UTF-8\n\n%s'%(len(configpage), configpage))
                return 0
            elif requestpath[0] == '/dmx' and method == 'POST':
                dmx.set_channels(body['dmx'])
                self.sendresponse(conn, 'HTTP/1.0 200 OK\n\n')
                return 0
            elif requestpath[0] == '/rgb' and method == 'GET':
                dmx.dmx_values[int(query['address'])] = query['r']
                dmx.dmx_values[int(query['address'])+1] = query['g']
                dmx.dmx_values[int(query['address'])+2] = query['b']
                self.sendresponse(conn, 'HTTP/1.0 200 OK\n\n')
                return 0
            elif requestpath[0] == '/fadeto' and method == 'GET':
                f.addrgbfade(dmx, int(query['address']), {'r': query['r'], 'g': query['g'], 'b': query['b']}, query['time'])
                self.sendresponse(conn, 'HTTP/1.0 200 OK\n\n')
                return 0
            else:
                self.sendresponse(conn, 'HTTP/1.0 404 NOT FOUND\n\nFile Not Found')
                return -1

    def sendresponse(self, conn, response):
        conn.sendall(response.encode())
        conn.close()
        return 0